//Ringslinger abilities by Lactozilla

/*Since v2.2 got out, most of the code here is kinda redundant as of no one
actually plays ringslinger anymore.
However, most of the code got reused for the Team Kinetic update for SRB2 Battle
Mainly Snow mine and Ice wall and the freezing mechanic.
Battlemod stuff is suported for v9 and v9 alone.
Battlemod assistance for exhaust function from Krabs
*/
local camera = nil
hud.add(function(v, player, _camera)
	camera = _camera
end, "game")

local function AIMINGTOSLOPE(aiming)
	return sin(aiming)
end

local function checksameteam(p1, p2)
	if CV_FindVar("friendlyfire").value then
		return false
	elseif G_TagGametype() then
		return ((p1.pflags & PF_TAGIT) == (p2.pflags & PF_TAGIT))
	elseif G_GametypeHasTeams() then
		return (p1.ctfteam == p2.ctfteam)
	elseif (gametyperules & GTR_FRIENDLY) then
		return true
	end
	return false
end

local dirk_setdeathmatchweapons
local dirk_setdeathmatchweapondelay
local dirk_setdeathmatchiceshardweapondelay
local dirk_fireweapon
local dirk_indeathmatch
local dirk_deathmatchthinker
local dirk_freezeparticlesicespray
local dirk_freezeparticles
local dirk_snowstormthinker
local dirk_iceminesnowstorm
local dirk_icewallgenerator
local dirk_icewallgenerator_battle
local dirk_icewalldespawn
local dirk_icewallsegmentbreak
local dirk_frozenplayer
local dirk_icespraycollision
local dirk_icespraythinker

local spawn_missile
local spawn_missile_xyz
local spawn_missile_player
local missile_properties
local spray_particle

local freezethawbuttonpresses = 8
local snowstormicesprayfreezeradius = 128*FRACUNIT
local sprayfreezetime = 3*TICRATE
local sprayminspeed = 12*FRACUNIT

local function dirk_getweapon_internal(weapon)
	if weapon == 2
		return 3
	elseif weapon == 3
		return 6
	else
		return 0
	end
end
rawset(_G, "dirk_getweapon", dirk_getweapon_internal)

//Hurt Messages <-- assistance from switchKaze

local function iceHurt(p, ring, attack)
	if not ring then return end
	local colorflag, colorflag2
	local rst = "\x80"
	local p2 = ring.target.player
	if not G_GametypeHasTeams()
		colorflag = ""
		colorflag2 = ""
	else
		if p.ctfteam == 1
			colorflag = "\x85"
		elseif p.ctfteam == 2
			colorflag = "\x84"
		else
			colorflag = rst
		end
		if p2.ctfteam == 1
			colorflag2 = "\x85"
		elseif p2.ctfteam == 2
			colorflag2 = "\x84"
		else
			colorflag2 = rst
		end
	end
	local p2_name = p2.name
	if ring.flags2 & MF2_BEYONDTHEGRAVE then
		p2_name = "The late " .. $
	end
	print(colorflag2..p2_name..rst.."'s "..attack.." "..colorflag..p.name..rst..".")
end

function dirk_setdeathmatchweapons(dirk, set)
	for i=pw_automaticring,pw_railring do
		dirk.powers[i] = 0
	end
	if set then
		dirk.powers[pw_scatterring] = 1
		dirk.powers[pw_railring] = 1
		dirk.ringweapons = RW_SCATTER|RW_RAIL
	else
		dirk.powers[pw_scatterring] = 0
		dirk.powers[pw_railring] = 0
		dirk.ringweapons = 0
		dirk.dirk_dmweapons = nil
		dirk.dirk_dmattack = 0
		dirk.dirk_dmfirenormal = 0
		dirk.dirk_dmweapondelay = {0,0,0,0}
		dirk.weapondelay = 0
	end
	dirk.dirk_deathmatch = set
end

function dirk_setdeathmatchweapondelay(dirk, weapon, delay)
	dirk.dirk_dmweapondelay[weapon] = delay
end

function dirk_fireweapon(dirk, rings)
	if (rings ~= nil) then
		if ((dirk.rings - rings) < 0) then return false end
	end
	dirk.rings = $-(rings or 1)
	return true
end

function dirk_indeathmatch(dirk)
	if (not G_RingSlingerGametype()) then return false end
	if G_TagGametype() and (not (dirk.pflags & PF_TAGIT)) then return false end
	if (gametype == GT_TRON) then return false end
	return true
end

function missile_properties(mo, angle, aiming, speed)
	mo.angle = angle
	mo.momx = FixedMul(mo.scale, FixedMul(FixedMul(speed, cos(angle)), cos(aiming)))
	mo.momy = FixedMul(mo.scale, FixedMul(FixedMul(speed, sin(angle)), cos(aiming)))
	mo.momz = FixedMul(mo.scale, FixedMul(speed, AIMINGTOSLOPE(aiming)*P_MobjFlip(mo)))
end

function spawn_missile(source, type, angle, aiming, source2, speed)
	local mo = P_SpawnMobj(source.x, source.y, source.z, type)
	mo.target = (source2 or source)
	if (mo.target and mo.target.valid) then
		mo.scale = mo.target.scale
		mo.eflags = $|(mo.target.eflags & MFE_VERTICALFLIP)
		mo.flags2 = $|(mo.target.flags2 & MF2_OBJECTFLIP)
	end
	if (mo and mo.valid) then
		missile_properties(mo, angle, aiming, (speed or mo.info.speed))
	end
	return mo
end

function spawn_missile_xyz(source, x, y, z, type, angle, aiming, source2, speed)
	local mo = P_SpawnMobj(x, y, z, type)
	mo.target = (source2 or source)
	if (mo.target and mo.target.valid) then
		mo.scale = mo.target.scale
		mo.eflags = $|(mo.target.eflags & MFE_VERTICALFLIP)
		mo.flags2 = $|(mo.target.flags2 & MF2_OBJECTFLIP)
	end
	if (mo and mo.valid) then
		missile_properties(mo, angle, aiming, (speed or mo.info.speed))
	end
	return mo
end

function spawn_missile_player(player, type, angle, aiming, speed)
	local mo = P_SpawnPlayerMissile(player.mo, type)
	if (mo and mo.valid) then
		missile_properties(mo, angle, aiming, (speed or mo.info.speed))
	end
	return mo
end

function spray_particle(player, type, a, b, c)
	local spray = nil
	local angle = player.mo.angle
	local aiming = player.aiming
	local ra = P_RandomRange(0,a)
	local r = (360-ra)
	if P_RandomChance(FRACUNIT/3) then
		r = ra
	end
	r = FixedAngle($*FRACUNIT)
	aiming = player.aiming+r
	angle = $+FixedAngle(P_RandomRange(-b,b)*FRACUNIT)
	spray = spawn_missile_player(player, type, angle, aiming, 30*FRACUNIT + player.speed)
	if (spray and spray.valid) then
		spray.scale = FixedMul($, P_RandomFixed()*(c or 1))
		if (camera ~= nil)
		and (not camera.chase) then
			spray.flags2 = $|MF2_DONTDRAW
		end
		spray.translucency = 0
	end
	return spray
end

function dirk_deathmatchthinker(player)
	local pmo = player.mo
	if (pmo.skin ~= "dirk")
	or (not dirk_indeathmatch(player)) then
		if player.dirk_deathmatch then
			dirk_setdeathmatchweapons(player, false)
		end
		return
	end

	if (not player.dirk_deathmatch) then
		player.dirk_dmweapons = {1,1,1,1}
		player.dirk_deathmatch = true
	end
	dirk_setdeathmatchweapons(player, true)

	if (player.dirk_dmweapondelay == nil) then
		player.dirk_dmweapondelay = {0,0,0,0}
	end
	if (player.dirk_dmattack == nil) then
		player.dirk_dmattack = 0
	end
	if (player.dirk_dmfirenormal == nil) then
		player.dirk_dmfirenormal = 0
	end
	player.dirk_dmattack = (player.cmd.buttons & BT_ATTACK) and $+1 or 0
	player.dirk_dmfirenormal = (player.cmd.buttons & BT_FIRENORMAL) and $+1 or 0

	local delay = 1
	if (player.currentweapon == dirk_getweapon(1)) then
		delay = $+(player.dirk_dmweapondelay[4])
	elseif (player.currentweapon == dirk_getweapon(2)) then
		delay = $+(player.dirk_dmweapondelay[2])
	elseif (player.currentweapon == dirk_getweapon(3)) then
		delay = $+(player.dirk_dmweapondelay[3])
	end
	player.weapondelay = delay
	player.ammoremovaltimer = 0

	local weapondelay = player.dirk_dmweapondelay
	for weapon=1,#weapondelay do
		if (weapondelay[weapon]) then
			weapondelay[weapon] = $-1
		end
	end

	local function canfireweapon()
		if (player.rings <= 0) then return false end
		return true
	end

	if (pmo.state >= S_PLAY_SUPER_TRANS1)
	and (pmo.state <= S_PLAY_SUPER_TRANS6) then
		return
	end

	local w_hold = (player.dirk_dmattack >= 1)
	local w_press = (player.dirk_dmattack == 1)
	if (player.dirk_dmfirenormal == 1)
	and (player.dirk_dmweapons[4])
	and (not weapondelay[4]) then
		local fire = canfireweapon()
		if (not fire) then
			fire = player.powers[pw_infinityring]
		end
		if fire then
			local shard = P_SpawnPlayerMissile(pmo, MT_THROWNICESHARD)
			S_StartSound(pmo, sfx_thok)
			if (player.powers[pw_infinityring]) then
				player.powers[pw_infinityring] = $-1
			else
				dirk_fireweapon(player)
			end
			if (shard and shard.valid)
			and G_GametypeHasTeams() then
				shard.sprite = SPR_ICHC
				if (player.ctfteam == 2)
					shard.color = skincolor_bluering
				elseif (player.ctfteam == 1)
					shard.color = skincolor_redring
				end
			end
			dirk_setdeathmatchweapondelay(player, 4, (3*TICRATE)/2)
		end
	elseif (w_hold and canfireweapon())
	and (player.currentweapon == 0)
	and (player.dirk_dmweapons[1]) then
		for i=1,8 do
			spray_particle(player,MT_THROWNICESPRAY,15,5,P_RandomRange(1,3))
		end
		if ((leveltime % (TICRATE/2)) == 0) then
			dirk_fireweapon(player)
		end
		if (not S_SoundPlaying(pmo, sfx_icebth)) then
			S_StartSound(pmo, sfx_icebth)
		end
	elseif (w_press and canfireweapon()) then
		if (player.currentweapon == dirk_getweapon(2))
		and (not weapondelay[2])
		and (player.dirk_dmweapons[2]) then
			if (dirk_fireweapon(player, 10)) then
				dirk_setdeathmatchweapondelay(player, 2, 8*TICRATE)
				local mine = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_THROWNICEMINE)
				if (mine and mine.valid) then
					mine.target = pmo
					mine.scale = pmo.scale
					mine.eflags = $|(pmo.eflags & MFE_VERTICALFLIP)
					mine.flags2 = $|(pmo.flags2 & MF2_OBJECTFLIP)
					if G_GametypeHasTeams() then
						mine.state = S_THROWNTEAMICEMINE
						if (player.ctfteam == 2)
							mine.color = skincolor_bluering
						elseif (player.ctfteam == 1)
							mine.color = skincolor_redring
						end
					end
				end
				S_StartSound(mine, sfx_s3k56)
			end
		elseif (player.currentweapon == dirk_getweapon(3))
		and (not weapondelay[3])
		and (player.dirk_dmweapons[3]) then
			local dist = (pmo.radius * 10) + (player.speed * 4)
			local x = pmo.x + FixedMul(dist, cos(pmo.angle))
			local y = pmo.y + FixedMul(dist, sin(pmo.angle))
			local dummy = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_RING_BOX)
			local moveok = true
			if (dummy and dummy.valid) then
				dummy.flags = $|MF_NOCLIPTHING
				dummy.radius = mobjinfo[MT_ICEWALLGENERATOR].radius
				dummy.height = mobjinfo[MT_ICEWALLGENERATOR].height
				moveok = P_TryMove(dummy, x, y)
				P_RemoveMobj(dummy)
				if (not moveok) then
					S_StartSound(nil, sfx_bnce1, player)
					return
				end
			else
				S_StartSound(nil, sfx_bnce1, player)
				return
			end
			if (dirk_fireweapon(player, 5)) then
				dirk_setdeathmatchweapondelay(player, 3, 3*TICRATE)
				local generator = P_SpawnMobj(x, y, pmo.z, MT_ICEWALLGENERATOR)
				if (generator and generator.valid) then
					generator.target = pmo
					generator.angle = pmo.angle + ANGLE_90
					generator.scale = pmo.scale
					generator.eflags = $|(pmo.eflags & MFE_VERTICALFLIP)
					generator.flags2 = $|(pmo.flags2 & MF2_OBJECTFLIP)
					generator.z = $ + FixedMul(pmo.height, AIMINGTOSLOPE(player.aiming)*5)*P_MobjFlip(generator)
					if (generator.z < generator.floorz)
						generator.z = generator.floorz
					end
					if (generator.z > generator.ceilingz)
						generator.z = generator.ceilingz
					end
				end
			end
		end
	end
end

function dirk_freezeparticlesicespray(mo, _type)
	if (not mo) then return end
	if (not mo.valid) then return end
	local particle = nil
	local angle = mo.angle
	for i=1,128 do
		particle = P_SpawnMobj(mo.x, mo.y, (mo.eflags & MFE_VERTICALFLIP) and (mo.z - mo.height) or mo.z, (_type or MT_ICESPRAY))
		particle.angle = angle
		particle.scale = FixedMul(mo.scale, FixedMul($, P_RandomFixed()*P_RandomRange(1,4)))
		particle.eflags = $|(mo.eflags & MFE_VERTICALFLIP)
		particle.flags2 = $|(mo.flags2 & MF2_OBJECTFLIP)
		particle.translucency = FF_TRANS20
		P_InstaThrust(particle, particle.angle, FixedMul(particle.scale, FixedMul(particle.info.speed, P_RandomFixed()*P_RandomRange(1,4))))
		P_SetObjectMomZ(particle, FixedMul(particle.scale, FixedMul(particle.info.speed/3, P_RandomFixed()*P_RandomRange(1,4)))*P_MobjFlip(particle))
		angle = $+ANGLE_45
	end
end

function dirk_freezeparticles(player)
	if (not player.mo) then return end
	if (not player.mo.valid) then return end
	dirk_freezeparticlesicespray(player.mo)
end

local function dirk_freezeplayer_internal(player, inflictor, source)
	if (not player.mo) then return end
	if (not player.mo.valid) then return end
	player.mo.dirk_frozen = {
		k_jump = 0,
		k_pressed = 0,
		release = 0,
		willrelease = 0,
		bigjumpkey = nil,
	}
	player.dirk_frozen = true
	player.lastangle = player.mo.angle
	player.mo.blendmode = AST_ADD
	player.canguard = false
	player.airdodge = 0
	player.mo.dirk_icesprayhit = nil
	S_StartSound(player.mo, sfx_s3k80)
	dirk_freezeparticles(player)
	if CBW_Battle and CBW_Battle.BattleGametype() then
		P_SetObjectMomZ(player.mo, player.jumpfactor*8)
	else
		P_SetObjectMomZ(player.mo, player.jumpfactor*16)
	end	
end
rawset(_G, "dirk_freezeplayer", dirk_freezeplayer_internal)

local function dirk_unfreezeplayer_internal(player, respawning, pain)
	if (not player.mo) then return end
	if (not player.mo.valid) then return end
	if (not player.dirk_frozen) then return end
	if (not player.mo.dirk_frozen) then return end
	player.mo.reactiontime = 0
	player.mo.colorized = false
	player.mo.blendmode = AST_TRANSLUCENT
	player.mo.color = player.skincolor
	player.pflags = $ & ~PF_FORCESTRAFE
	player.normalspeed = skins[player.mo.skin].normalspeed
	if (player.mo.dirk_frozen.bigjumpkey and player.mo.dirk_frozen.bigjumpkey.valid) then
		P_RemoveMobj(player.mo.dirk_frozen.bigjumpkey)
	end
	if (not respawning) then
		if (not pain) then
			P_DoPlayerPain(player)
			player.mo.momx = 0
			player.mo.momy = 0
		end
		player.mo.flags = $1 & ~MF_BOUNCE
		player.mo.friction = 29*FRACUNIT/32
		local hzt = 12
		player.mo.z = $+(P_MobjFlip(player.mo)*(hzt*FRACUNIT))
		P_SetObjectMomZ(player.mo, player.jumpfactor*hzt)
		player.jumping = true
		player.pflags = $|PF_JUMPED|PF_THOKKED
		player.mo.state = S_PLAY_JUMP
		S_StartSound(player.mo, sfx_shattr)
		dirk_freezeparticles(player)
		player.actioncooldown = 3*TICRATE
	end
	player.mo.dirk_frozen = nil
	player.dirk_frozen = false
end
rawset(_G, "dirk_unfreezeplayer", dirk_unfreezeplayer_internal)

local function dirk_snowstormplayerfreezeiterator_internal(storm, source, distance, callback)
	for player in players.iterate do
		if (not (source and source.valid and source.player)) then break end
		if (player == source.player) then continue end
		if (player.mo and player.mo.valid and player.mo.health) then
			local dist = R_PointToDist2(storm.x, storm.y, player.mo.x, player.mo.y)
			local zdist = abs(storm.z - player.mo.z)
			if (dist <= distance)
			and (zdist <= distance)
			and (not player.powers[pw_flashing]) then
				callback(player.mo, source, storm)
			end
		end
	end
end
rawset(_G, "dirk_snowstormplayerfreezeiterator", dirk_snowstormplayerfreezeiterator_internal)

function dirk_snowstormthinker(mo)
	local spray = nil
	local x, y = 0, 0
	local function p(angle, aiming)
		x = mo.x + FixedMul(mo.radius, cos(angle))
		y = mo.y + FixedMul(mo.radius, sin(angle))
		spray = spawn_missile_xyz(mo, x, y, mo.z, MT_THROWNICESPRAY, angle, aiming, mo.target)
		if (spray and spray.valid) then
			spray.snowstorm = true
			spray.scale = FixedMul(mo.scale, FixedMul($, P_RandomFixed()*P_RandomRange(1,4)))
			spray.translucency = P_RandomRange(tr_trans20, tr_trans60)<<FF_TRANSSHIFT
		end
	end

	mo.angle = $+(FixedAngle(35<<FRACBITS))
	if mo.tracer and mo.tracer.valid then
		mo.tracer.angle = mo.angle
		if (not S_SoundPlaying(mo.tracer, sfx_icebth)) then
			S_StartSound(mo.tracer, sfx_icebth)
		end
		P_TeleportMove(mo, mo.tracer.x, mo.tracer.y, mo.tracer.z)
	end

	local time = (leveltime - mo.spawntime)
	if (time > TICRATE)
	and (time < mo.maxtime) then
		time = $-TICRATE
		mo.aiming = FixedAngle(min(min(time, 360)*3, mo.maxangle)*FRACUNIT)
		if ((leveltime % (TICRATE/4))==0) then
			mo.snowstorm = true
			dirk_snowstormplayerfreezeiterator(mo, mo.target,
			snowstormicesprayfreezeradius,
			function(target, source, storm)
				if (not target.player.dirk_frozen)
				and (not checksameteam(target.player, source.player)) then
					dirk_icespraycollision(target, mo, source)
				end
			end)
		end
	end
	if (time >= mo.maxtime) then
		time = $-(mo.maxtime)
		mo.aiming = $-(FixedAngle((time*3)*FRACUNIT)/4)
		if (mo.aiming < 0) then
			if mo.tracer and mo.tracer.valid then
				mo.tracer.state = S_XPLD1
			end
			P_RemoveMobj(mo)
			return
		end
	end

	if ((leveltime % 3)==0) then
		local _angle = mo.angle
		for i=1,8 do
			p(_angle, mo.aiming)
			_angle = $+(ANGLE_45/2)
		end
	end
end
addHook("MobjThinker", dirk_snowstormthinker, MT_ICESTORMGENERATOR)

function dirk_iceminesnowstorm(mo)
	local storm = P_SpawnMobj(mo.x, mo.y, mo.z, MT_ICESTORMGENERATOR)
	storm.target = mo.target
	storm.tracer = mo
	storm.scale = mo.scale
	if (storm.target) then
		storm.angle = storm.target.angle
		storm.radius = storm.target.radius
	end
	storm.aiming = 0
	storm.spawntime = leveltime
	storm.maxtime = 6*TICRATE
	storm.maxangle = 60
	S_StartSound(mo, sfx_appear)
end

addHook("MobjThinker", function(mo)
	if (P_IsObjectOnGround(mo) or P_IsObjectInGoop(mo))
	and (not (mo.flags2 & MF2_JUSTATTACKED)) then
		dirk_freezeparticlesicespray(mo)
		dirk_iceminesnowstorm(mo)
		mo.flags2 = $|MF2_JUSTATTACKED
		return
	end
end, MT_THROWNICEMINE)

function dirk_icewallgenerator(icewall)
	if (icewall.segments == nil) then
		icewall.segments = {}
		S_StartSound(icewall, sfx_icewal)
		for i=1,4 do
			icewall.segments[i] = P_SpawnMobj(0, 0, 0, MT_ICEWALLSEGMENT)
			icewall.segments[i].flags = $|MF_PAPERCOLLISION
			if (icewall.target and icewall.target.valid)
			and G_GametypeHasTeams() then
				local spawner = icewall.target.player
				if (spawner.ctfteam == 2)
					icewall.segments[i].color = skincolor_bluering
				elseif (spawner.ctfteam == 1)
					icewall.segments[i].color = skincolor_redring
				end
			end
		end
		dirk_freezeparticlesicespray(icewall)
		icewall.tick = 0
		icewall.broken = A
		icewall.paintics = 0
	end

	local brokencount = icewall.broken+1
	local wallbreak = {0, 2, 4, 6, 8}
	if (brokencount > #wallbreak) then
		P_SpawnSoundSource(sfx_shattr, TICRATE, icewall)
		dirk_freezeparticlesicespray(icewall)
		dirk_icewalldespawn(icewall)
		return
	end

	if (icewall.segments ~= nil) then
		local frontradius = 64
		local sideradius = frontradius*4
		for i=1,4 do
			if (not icewall.segments[i].valid) then continue end
			local an = icewall.angle + FixedAngle((90*i)<<FRACBITS)
			local rad = ((i == 2) or (i == 4)) and sideradius or frontradius
			local x = icewall.x + FixedMul((rad/2)*cos(an), icewall.scale)
			local y = icewall.y + FixedMul((rad/2)*sin(an), icewall.scale)
			icewall.segments[i].angle = an + ANGLE_90
			icewall.segments[i].scale = icewall.scale
			local frame = wallbreak[brokencount]
			local side = (i == 2) or (i == 4)
			if side then
				frame = $+1
			end
			local flipped = (icewall.eflags & MFE_VERTICALFLIP)
			icewall.segments[i].eflags = $|(icewall.eflags & MFE_VERTICALFLIP)
			icewall.segments[i].flags2 = $|(icewall.flags2 & MF2_OBJECTFLIP)
			icewall.segments[i].segframe = frame
			icewall.segments[i].sprite = G_GametypeHasTeams() and SPR_IWLC or SPR_IWAL
			icewall.segments[i].frame = frame|FF_PAPERSPRITE
			icewall.segments[i].radius = (not side) and 256*FRACUNIT or 64*FRACUNIT
			icewall.segments[i].tracer = icewall
			local z = icewall.z
			if flipped then
				z = $-icewall.segments[i].height
			end
			P_TeleportMove(icewall.segments[i], x, y, z)
		end
	end

	icewall.tick = $+1
	if (icewall.paintics) then
		icewall.paintics = $-1
	end
	local despawntick = 5*TICRATE
	if (icewall.tick > despawntick-20)
		for i=1,4 do
			if (not icewall.segments[i].valid) then continue end
			icewall.segments[i].flags = ($ & ~MF_PAPERCOLLISION)|MF_NOBLOCKMAP
			local alpha = min((icewall.tick-(despawntick-20)) / 2, 9)<<FF_TRANSSHIFT
			icewall.segments[i].frame = icewall.segments[i].segframe|alpha|FF_PAPERSPRITE
		end
	end
	if (icewall.tick > despawntick)
		dirk_icewalldespawn(icewall)
	end
end
addHook("MobjThinker", dirk_icewallgenerator, MT_ICEWALLGENERATOR)

function dirk_icewalldespawn(icewall)
	for i=1,4 do
		if (not icewall.segments[i].valid) then continue end
		P_RemoveMobj(icewall.segments[i])
	end
	P_RemoveMobj(icewall)
end

function dirk_icewallsegmentbreak(segment, weapon, source)
	local icewall = segment.tracer
	if (not icewall) then
		return false
	end
	if (icewall.paintics) then
		return false
	end
	if CBW_Battle and CBW_Battle.BattleGametype() then //We don't break the walls in battle
		return false
	end

	local target = icewall.target
	if (source and source.valid)
	and (source.player and (source ~= target))
	and (not checksameteam(source.player, target.player))
	and (weapon.type ~= MT_THROWNICESPRAY) then
		icewall.broken = $+1
		icewall.paintics = TICRATE/2
		S_StartSound(segment, sfx_icebrk)
		return false
	end

	return false
end
addHook("ShouldDamage", dirk_icewallsegmentbreak, MT_ICEWALLSEGMENT)

function dirk_frozenplayer(player)
	if (not player.mo) then return end
	if (not player.mo.valid) then return end

	local function flakes()
		if (not (leveltime % 3)) then //fancy ice flakes effect c:
			local flake = P_SpawnMobj(player.mo.x + P_RandomRange(-16,16)*player.mo.scale, player.mo.y + P_RandomRange(-16,16)*player.mo.scale, player.mo.z + P_RandomRange(16,64)*player.mo.scale, MT_PARTICLE)
			flake.scale = player.mo.scale
			flake.state = S_ICEFLAKE1
			flake.eflags = $ | (player.mo.eflags & MFE_VERTICALFLIP)
			flake.tics = 3
		end
	end

	if (player.mo.dirk_icesprayhit ~= nil) then
		local ish = player.mo.dirk_icesprayhit
		player.normalspeed = FixedMul(skins[player.mo.skin].normalspeed, ish[2])
		player.mo.color = SKINCOLOR_ICY
		player.mo.colorized = true
		if (ish[2]) then
			if (player.normalspeed < sprayminspeed) then
				player.normalspeed = sprayminspeed
			end
			if ((leveltime % 3) == 0)
			and (ish[2] >= sprayfreezetime-7)
			and (player.rings > 0) then
				player.rings = $-1
			end
		end
		ish[2] = $-1
		if (not ish[2]) then
			player.mo.dirk_icesprayhit = nil
			player.dirk_icesprayhit = false
			player.normalspeed = skins[player.mo.skin].normalspeed
			player.mo.color = player.skincolor
			player.mo.colorized = false
			return
		end
		flakes()
		return false, true
	end

	local f = player.mo.dirk_frozen
	if (f == nil) then return end
	if (type(f) ~= "table") then return end

	f.k_jump = (player.cmd.buttons & BT_JUMP) and $+1 or 0

	local release = false
	if (not f.willrelease) then
		release = (f.k_jump == 1)
		if release then
			f.k_pressed = TICRATE/2
			if P_IsObjectOnGround(player.mo) then
				P_InstaThrust(player.mo, FixedAngle(P_RandomRange(0,360)<<FRACBITS), FRACUNIT)
				P_SetObjectMomZ(player.mo, FRACUNIT/2)
			end
		end
	end
	if (release) then
		f.release = $+FixedDiv(F*FRACUNIT, freezethawbuttonpresses*FRACUNIT)
	end
	
	if P_IsValidSprite2(player.mo, SPR2_FROZ)
		player.mo.sprite2 = SPR2_FROZ
		player.mo.frame = A
		if (player.mo.sprite2 == SPR2_FROZ) then
			if (f.k_pressed) then
				player.mo.frame = B
			end
		end
	else
		player.mo.sprite2 = SPR2_DEAD
		player.mo.frame = A
	end
	if (player.followmobj and player.followmobj.valid)
	and (player.followmobj.type == MT_TAILSOVERLAY) then
		player.followmobj.state = S_INVISIBLE
	end
	
	if (f.k_pressed) then
		f.k_pressed = $-1
	end

	if (f.willrelease) then
		f.willrelease = $-1
		if (not f.willrelease) then
			dirk_unfreezeplayer(player)
			player.mo.dirk_frozen = nil
			player.dirk_frozen = false
			return
		end
	elseif (FixedInt(f.release) >= F) then
		f.willrelease = 1
	end

	if (player.speed or f.k_pressed) then
		flakes()
	end

	player.mo.reactiontime = 2
	player.normalspeed = skins[player.mo.skin].normalspeed
	player.pflags = $1|PF_FORCESTRAFE
	player.mo.friction = 31*FRACUNIT/32

	if not (player.pflags & PF_SLIDING) then
		player.mo.angle = player.lastangle
		player.mo.flags = $1|MF_BOUNCE
	else
		player.mo.flags = $1 & ~MF_BOUNCE
	end

	if (player.mo.skin ~= "uglyknux") //You people and your god darn memes
		player.mo.color = SKINCOLOR_ICY
		player.mo.colorized = true
	else
		player.mo.colorized = false
	end

	//Yea, you can freeze egg robo too and freeze his jets.
	if (player.mo.skin == "eggrobo")
		if player.dirk_frozen == true
			player.eggtime = 0
			player.eggstate = 0
			player.eggcooldown = max($,2)
			player.actioncooldown = TICRATE //Check for battle support. Thanks CobaltBW
		end
	end
	
	local key = player.mo.dirk_frozen.bigjumpkey
	local keyScale = FixedMul(FRACUNIT/2, player.mo.scale)
	if (not key)
	or (key and (not player.mo.dirk_frozen.bigjumpkey.valid)) then
		key = P_SpawnMobj(0, 0, 0, MT_BIGJUMPKEY)
		key.target = player.mo
		key.scale = keyScale
		player.mo.dirk_frozen.bigjumpkey = key
	end

	P_TeleportMove(key, player.mo.x, player.mo.y, 0)

	local offset = 24*FRACUNIT
	if (player.mo.eflags & MFE_VERTICALFLIP)
		key.z = player.mo.z - mobjinfo[MT_BIGJUMPKEY].height - offset
		key.eflags = $ | MFE_VERTICALFLIP
	else
		key.z = player.mo.z + player.mo.height + offset
		key.eflags = $ & ~MFE_VERTICALFLIP
	end
	key.sprite = states[S_BIGJUMPKEY].sprite + (leveltime/8)%2
	if (player ~= displayplayer)
	or (splitscreen) then
		key.flags2 = $ | MF2_DONTDRAW
	else
		key.flags2 = $ & ~MF2_DONTDRAW
	end

	if (f.k_pressed == 15) then
		S_StartSound(player.mo, sfx_s3k94)
		key.scale = keyScale - FixedMul(FRACUNIT>>4, player.mo.scale)
		key.destscale = keyScale
		key.scalespeed = FRACUNIT/32
	end

	local function ibsfc()
		player.mo.dirk_iceblock.solidblockcollide = P_SpawnMobj(0, 0, 0, MT_ICEBLOCKSOLIDCOLLIDE)
		player.mo.dirk_iceblock.solidblockcollide.target = player.mo
	end

	if not (player.mo.dirk_iceblock and player.mo.dirk_iceblock.valid) then
		player.mo.dirk_iceblock = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_ICEBLOCK)
		player.mo.dirk_iceblock.target = player.mo
		player.mo.dirk_iceblock.walls = {}
		for i=1,4 do
			player.mo.dirk_iceblock.walls[i] = P_SpawnMobj(0, 0, 0, MT_ICEBLOCKWALL)
		end
		ibsfc()
	else
		player.mo.dirk_iceblock.frame = min(FixedInt(f.release), F)
		local radius = 64
		for i=1,4 do
			local an = player.mo.angle + ANG1*90*i
			local x = player.mo.x + FixedMul((radius/2)*cos(an), player.mo.scale)
			local y = player.mo.y + FixedMul((radius/2)*sin(an), player.mo.scale)
			if player.mo.dirk_iceblock
			and player.mo.dirk_iceblock.valid
			and player.mo.dirk_iceblock.walls
			and player.mo.dirk_iceblock.walls[i]
			and player.mo.dirk_iceblock.walls[i].valid then
				P_TeleportMove(player.mo.dirk_iceblock.walls[i], x, y, player.mo.z)
				player.mo.dirk_iceblock.walls[i].angle = an + ANG1*90
				player.mo.dirk_iceblock.walls[i].scale = player.mo.scale
				player.mo.dirk_iceblock.walls[i].frame = player.mo.dirk_iceblock.frame|FF_PAPERSPRITE
			end
		end
		if player.mo.dirk_iceblock.solidblockcollide and player.mo.dirk_iceblock.solidblockcollide.valid
			P_TeleportMove(player.mo.dirk_iceblock.solidblockcollide, player.mo.x, player.mo.y, player.mo.z)
		elseif player.mo.dirk_iceblock.solidblockcollide and (not player.mo.dirk_iceblock.solidblockcollide.valid) then
			ibsfc()
		elseif (not player.mo.dirk_iceblock.solidblockcollide) and (not player.mo.dirk_iceblock.solidblockcollide.valid) then
			ibsfc()
		end
	end

	return true, false, f.release
end

addHook("PlayerSpawn", function(player)
	if (player.dirk_frozen) then
		dirk_unfreezeplayer(player, true)
	end
	player.dirk_frozen = false
end)

addHook("MapLoad", do
	for player in players.iterate do
		if player.mo and player.mo.valid
		and player.dirk_frozen then
			dirk_unfreezeplayer(player, true)
		end
	end
end)

function dirk_icespraycollision(target, weapon, source)
	if (not target.player) then return end
	if (target.dirk_icesprayhit == nil) then
		target.dirk_icesprayhit = {FRACUNIT, 0, -1, false}
		if (not P_IsObjectOnGround(target)) then
			target.momx = $/2
			target.momy = $/2
		end
	end
	local ish = target.dirk_icesprayhit
	local snowstorm = ish[4]
	if (ish[3] != leveltime) then
		ish[1] = $-(FRACUNIT/12)
	end
	ish[2] = sprayfreezetime
	ish[3] = leveltime
	ish[4] = weapon.snowstorm
	if (ish[1] < 1) then
		dirk_freezeplayer(target.player, weapon, source)
		if (netgame) then
			iceHurt(target.player, weapon, "froze")
		end
	end
end

addHook("ShouldDamage", function(target, weapon, source)
	if (weapon and weapon.valid)
	and (target.player and target.health)
	and (weapon.target and weapon.target.valid and weapon.target.player and (weapon.target ~= target))
	and (not target.player.powers[pw_flashing]) then
		if (not source) then return false end
		if (not source.valid) then return false end
		if (not source.player) then return false end 
		if (checksameteam(source.player, target.player)) then return false end
		if (weapon.type == MT_THROWNICESPRAY) then
			if (not target.dirk_frozen) then
				dirk_icespraycollision(target, weapon, source)
			end
			return false
		else
			dirk_unfreezeplayer(target.player, false, true)
			if (weapon.type == MT_THROWNICESHARD) then
				weapon.flags2 = $|MF2_RAILRING|MF2_EXPLOSION
			end
			return
		end
		return false
	end
end, MT_PLAYER)

addHook("MobjDamage", function(target)
	if not (target and target.valid and target.health) return end
	if (target.player) then
		if target.icesurf then
			target.colorized = false
		else
			dirk_unfreezeplayer(target.player, false, true)
		end
	end
end, MT_PLAYER)

addHook("HurtMsg", function(player, weapon)
	iceHurt(player, weapon, "ice shard "..((player.mo.health <= 0) and "killed" or "hit"))
	return true
end, MT_THROWNICESHARD)

addHook("ShouldDamage", function(target, weapon)
	if (weapon and weapon.valid)
	and (weapon.type == MT_ICESPRAY) then
		return true
	end
end, MT_PLAYER)

addHook("ThinkFrame", do
	for player in players.iterate
		if (not player.mo) or (not player.mo.health) then continue end
		dirk_deathmatchthinker(player)
		local _, isspray, releasehits = dirk_frozenplayer(player)
		player.dirk_hitbyicespray = isspray
		player.dirk_frozenreleasehits = releasehits
	end
end)

function dirk_icespraythinker(mo)
	mo._tics = ($ or 0)+1
	local tick = mo._tics
	if (not mo.immediate) then
		tick = ($ - TICRATE/6)
	end
	if (tick > 0) and ((tick % (mo.animation_speed or TICRATE/8)) == 0) then
		mo.animation_frame = ($ or A)+1
		if (mo.animation_frame > F) then
			P_RemoveMobj(mo)
			return
		end
	end
	mo.frame = (mo.animation_frame or A)
	if (mo.translucency == nil) then
		mo.frame = $|FF_TRANS80
	else
		mo.frame = $|mo.translucency
	end
end

addHook("MobjThinker", dirk_icespraythinker, MT_ICESPRAY)
addHook("MobjThinker", function(mo)
	dirk_icespraythinker(mo)
	if (not mo.valid) then return end
	if (camera ~= nil)
	and (not camera.chase) then
		if (splitscreen) then
			mo.flags2 = $ & ~MF2_DONTDRAW
		else
			if (R_PointToDist(mo.x, mo.y) < 128*FRACUNIT) then
				mo.flags2 = $|MF2_DONTDRAW
			else
				mo.flags2 = $ & ~MF2_DONTDRAW
			end
		end
	end
end, MT_THROWNICESPRAY)

addHook("MobjSpawn", function(mo)
	mo.fuse = TICRATE-9
	mo.frame = A|FF_TRANS30
end, MT_ICESPRAYPARTICLE)

for wep=MT_BOUNCEPICKUP,MT_GRENADEPICKUP do
	addHook("MobjDeath", function(target, inflictor, source)
		if (source and source.valid and source.player)
		and (source.skin == "dirk") then
			P_GivePlayerRings(source.player, 10)
		end
	end, wep)
end
for wep=MT_BOUNCERING,MT_GRENADERING do
	if (wep == MT_INFINITYRING) then continue end
	addHook("MobjDeath", function(target, source, source)
		if (source and source.valid and source.player)
		and (source.skin == "dirk") then
			P_GivePlayerRings(source.player, 5)
		end
	end, wep)
end

//Dirk vs. Silver stuff
local vsice = {
	nograb = false,
	noaim = false,
	noroll = false,
	killonwall = true,
	killonfloor = true,
	nodamage = false,
}

local tkextraadded = false

addHook("ThinkFrame", do
	if (tkextraadded) then return end
	if (silv_addTKextra) then
		silv_addTKextra(MT_THROWNICESHARD, vsice)
		tkextraadded = true
	end
end)


// Battle Support lua
// Co-written by CobaltBW

local DirkBattle = false
--local B = CBW_Battle
local dirk_cooldown1 = TICRATE*4
local dirk_cooldown2 = TICRATE*7

function dirk_icewallgenerator_battle(icewall)
	if (icewall.segments == nil) then
		icewall.segments = {}
		S_StartSound(icewall, sfx_icewal)
		for i=1,4 do
			icewall.segments[i] = P_SpawnMobj(0, 0, 0, MT_ICEWALLSEGMENT)
			icewall.segments[i].flags = $|MF_PAPERCOLLISION
			--icewall.segments[i].spritexscale = FRACUNIT/2
			--icewall.segments[i].spriteyscale = FRACUNIT/2
			if (icewall.target and icewall.target.valid)
				if G_GametypeHasTeams() then
					local spawner = icewall.target.player
					if (spawner.ctfteam == 2)
						icewall.segments[i].color = skincolor_bluering
					elseif (spawner.ctfteam == 1)
						icewall.segments[i].color = skincolor_redring
					end
				else
					icewall.segments[i].color = icewall.target.color
				end
			end
		end
		dirk_freezeparticlesicespray(icewall)
		icewall.tick = 0
	end

	if (icewall.segments ~= nil) then
		local frontradius = 64
		local sideradius = frontradius*4
		for i=1,4 do
			if (not icewall.segments[i].valid) then continue end
			local an = icewall.angle + FixedAngle((90*i)<<FRACBITS)
			local rad = ((i == 2) or (i == 4)) and sideradius or frontradius
			local x = icewall.x + FixedMul((rad/4)*cos(an), icewall.scale)
			local y = icewall.y + FixedMul((rad/4)*sin(an), icewall.scale)
			icewall.segments[i].angle = an + ANGLE_90
			icewall.segments[i].flags = $|MF_PAPERCOLLISION
			icewall.segments[i].scale = icewall.scale/2
			--icewall.segments[i].spritexscale = FRACUNIT/2
			--icewall.segments[i].spriteyscale = FRACUNIT/2
			local frame = 0
			local side = (i == 2) or (i == 4)
			if side then
				frame = $+1
			end
			local flipped = (icewall.eflags & MFE_VERTICALFLIP)
			icewall.segments[i].eflags = $|(icewall.eflags & MFE_VERTICALFLIP)
			icewall.segments[i].flags2 = $|(icewall.flags2 & MF2_OBJECTFLIP)
			icewall.segments[i].segframe = frame
			icewall.segments[i].sprite = SPR_IWLC
			icewall.segments[i].frame = frame|FF_PAPERSPRITE
			icewall.segments[i].flags = $|MF_PAPERCOLLISION
			--icewall.segments[i].spritexscale = FRACUNIT/2
			--icewall.segments[i].spriteyscale = FRACUNIT/2
			icewall.segments[i].radius = (not side) and 64*FRACUNIT or 16*FRACUNIT
			icewall.segments[i].tracer = icewall
			local z = icewall.z
			if flipped then
				z = $-icewall.segments[i].height
			end
			P_TeleportMove(icewall.segments[i], x, y, z)
		end
	end
	icewall.tick = $+1	
	local despawntick = 5*TICRATE
	if (icewall.tick > despawntick-20)
		for i=1,4 do
			if (not icewall.segments[i].valid) then continue end
			icewall.segments[i].flags = ($ & ~MF_PAPERCOLLISION)|MF_NOBLOCKMAP
			local alpha = min((icewall.tick-(despawntick-20)) / 2, 9)<<FF_TRANSSHIFT
			icewall.segments[i].frame = icewall.segments[i].segframe|alpha|FF_PAPERSPRITE
		end
	end
	if (icewall.tick > despawntick)
		dirk_icewalldespawn(icewall)
	end
end
addHook("MobjThinker", dirk_icewallgenerator_battle, MT_ICEWALLGENERATOR_BATTLE)

local function DirkSpecial(mo,doaction,pressedaction)
	local player = mo.player
	
	if not(CBW_Battle.CanDoAction(player)) then
		player.actionstate = 0
	return end
	
	//Action Info
	if P_IsObjectOnGround(mo) then
		player.actiontext = "Ice Wall"
		player.actionrings = 10
	else
		player.actiontext = "Snow mine"
		player.actionrings = 10
	end
	player.action2text = nil
	if player.actionstate != 0 then player.canguard = false end

	if player.actionstate == 0
		if doaction == 1 then
			CBW_Battle.PayRings(player)
			if P_IsObjectOnGround(mo)
				local dist = (mo.radius * 10) + (player.speed * 4)
				local x = mo.x + FixedMul(dist, cos(mo.angle))
				local y = mo.y + FixedMul(dist, sin(mo.angle))
				local generator = P_SpawnMobj(x, y, mo.z, MT_ICEWALLGENERATOR_BATTLE)
				if (generator and generator.valid) then
					generator.target = mo
					generator.angle = mo.angle + ANGLE_90
					generator.scale = mo.scale
					generator.eflags = $|(mo.eflags & MFE_VERTICALFLIP)
					generator.flags2 = $|(mo.flags2 & MF2_OBJECTFLIP)
					generator.z = $ + FixedMul(mo.height, AIMINGTOSLOPE(player.aiming)*5)*P_MobjFlip(generator)
					if (generator.z < generator.floorz)
						generator.z = generator.floorz
					end
					if (generator.z > generator.ceilingz)
						generator.z = generator.ceilingz
					end
				end
				CBW_Battle.ApplyCooldown(player,dirk_cooldown1)
			else
				local mine = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THROWNICEMINE)
				if (mine and mine.valid) then
					mine.target = mo
					mine.sprite = SPR_ICBC
					mine.scale = mo.scale
					mine.eflags = $|(mo.eflags & MFE_VERTICALFLIP)
					mine.flags2 = $|(mo.flags2 & MF2_OBJECTFLIP)
					if G_GametypeHasTeams() then
						mine.state = S_THROWNTEAMICEMINE
						if (player.ctfteam == 2)
							mine.color = skincolor_bluering
						elseif (player.ctfteam == 1)
							mine.color = skincolor_redring
						end
					else
						mine.color = mo.color
					end
				end
				S_StartSound(mine, sfx_s3k56)
				CBW_Battle.ApplyCooldown(player,dirk_cooldown2)
			end
		end
	end
end

local function stopsurfing(mo)
	mo.icesurf = false
	mo.icefactor = 0
    mo.surfstarted = nil
    mo.colorized = false
    if (mo.ctn == nil) then
		mo.ctn = 0
	end
	mo.ctn = $+1
end
    
local KineticExhaustD = function(player)
	local mo = player.mo
	if mo.icesurf
	and mo.icebank
		local maxtime = (3*TICRATE)-14
		player.exhaustmeter = max(0,$-FRACUNIT/maxtime)
		if player.exhaustmeter <= 0
			if (player.cmd.buttons & BT_JUMP) and mo.standonfreeze
				player.pflags = $ & ~PF_JUMPSTASIS | PF_JUMPDOWN
				if mo.freeze.valid
					P_RemoveMobj(mo.freeze) //Gets rid of the current chunk so Dirk doesn't accidentally trigger other shit
				end
				S_StopSoundByID(mo, sfx_icesrf)
				S_StopSoundByID(mo, sfx_s3kcfl)
				P_DoJump(player) //Makes Dirk jump if he stops ice surfing while rising!
			elseif mo.state == S_PLAY_SURF
				mo.state = S_PLAY_WALK
			end
			mo.iceregen = true
			stopsurfing(mo)
			player.normalspeed = skins["dirk"].normalspeed
		end
		return true
	end
	if mo.standonfreeze
		return true
	end
	return false
end
	
addHook("ThinkFrame",function()
	if (CBW_Battle and not DirkBattle)

		CBW_Battle.SkinVars["dirk"] = {
			weight = 95,
			shields = 1,
			special = DirkSpecial,
			guard_enabled = true,
			guard_frame = 2,
			func_exhaust = KineticExhaustD
		}
		
		DirkBattle = true	
		print("Dirk BattleMod functions have been loaded.")
	end
end)