local flagoffs = {0, 0} // static
local shieldoffs = {0, 0} // static

local function dirk_ringslingerstatusbar(v, player)
	local pwrup = {
		x = 288,
		y = 176,
		f = V_SNAPTORIGHT|V_SNAPTOBOTTOM
	}

	if (player.spectator) then return end
	if (not player.mo) then return end
	if (not player.mo.valid) then return end

	local offs = pwrup.x
	local q = 1
	if (splitscreen and player == secondarydisplayplayer) then
		q = 2
	end
	local ICONSEP = (16+4) // matches weapon rings HUD

	/*if (F_GetPromptHideHud(hudinfo[HUD_POWERUPS].y))
		return
	end*/

	if (player.spectator or player.playerstate != PST_LIVE)
		return
	end

// -------
// Shields
// -------

	// Graue 06-18-2004: no V_NOSCALESTART, no SCX, no SCY, snap to right
	if (player.powers[pw_shield] & SH_NOSTACK)
		shieldoffs[q] = ICONSEP
	elseif (shieldoffs[q])
		if (shieldoffs[q] > 1)
			shieldoffs[q] = 2*shieldoffs[q]/3
		else
			shieldoffs[q] = 0
		end
	end

	offs = $ - shieldoffs[q]

// ---------
// CTF flags
// ---------

	// YOU have a flag. Display a monitor-like icon for it.
	if (player.gotflag)
		flagoffs[q] = ICONSEP
	elseif (flagoffs[q])
		if (flagoffs[q] > 1)
			flagoffs[q] = 2*flagoffs[q]/3
		else
			flagoffs[q] = 0
		end
	end

	offs = $ - flagoffs[q]

// --------------------
// Timer-based powerups
// --------------------

	// Invincibility, both from monitor and after being hit
	local invulntime = 0
	if (player.powers[pw_flashing])
		invulntime = player.powers[pw_flashing]
	else
		invulntime = player.powers[pw_invulnerability]
	end

	if (invulntime > 7)
		offs = $ - ICONSEP
	else
		local _a = ICONSEP
		local _b = 7-invulntime
		while (_b) do
			_a = 2*_a/3
			_b = $-1
		end
		offs = $ - _a
	end

	// Super Sneakers
	if (player.powers[pw_sneakers] > 7)
		offs = $ - ICONSEP
	else
		local _a = ICONSEP
		local _b = 7-player.powers[pw_sneakers]
		while (_b) do
			_a = 2*_a/3
			_b = $-1
		end
		offs = $ - _a
	end

	// Gravity Boots
	if (player.powers[pw_gravityboots] > 7)
		offs = $ - ICONSEP
	else
		local _a = ICONSEP
		local _b = 7-player.powers[pw_gravityboots]
		while (_b) do
			_a = 2*_a/3
			_b = $-1
		end
		offs = $ - _a
	end

	local pat = nil
	local timer = nil
	if (player.dirk_hitbyicespray) then
		pat = "SICEICON"
	elseif (player.dirk_frozen) then
		pat = "FRZNICON"
		timer = 7
		if player.dirk_frozenreleasehits then
			timer = 6 - FixedInt(player.dirk_frozenreleasehits)
		end
	end

	if (pat ~= nil) then
		v.drawScaled(offs<<FRACBITS, (pwrup.y)<<FRACBITS, FRACUNIT/2, v.cachePatch(pat), V_PERPLAYER|pwrup.f|V_HUDTRANS)
		if (timer ~= nil) then
			v.drawString(offs + 16, pwrup.y + 8, timer, V_PERPLAYER|pwrup.f|V_HUDTRANS, "thin-right") // has V_HUDTRANS unlike the broken in-game version
		end
	end
end

hud.add(function(v, player, camera)
	if (not (maptol & TOL_NIGHTS)) then
		local pwrupdisplay = 1
		if (CV_FindVar ~= nil) then
			pwrupdisplay = CV_FindVar("powerupdisplay").value
		end
		if (pwrupdisplay == 1 and (not camera.chase)) then
			dirk_ringslingerstatusbar(v, player)
		elseif (pwrupdisplay == 2) then
			dirk_ringslingerstatusbar(v, player)
		end
	end
	if player.mo and player.mo.valid and (player.mo.skin == "dirk") and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and player.mo.icebank ~= nil
	
		local xpos, ypos, nxpos, nypos
		local oflags = V_PERPLAYER|V_SNAPTOBOTTOM
		local flags = oflags
		local icon
		
		if (player.dirk_dmweapondelay == nil) then return end
		if not G_RingSlingerGametype() or G_TagGametype() and not (player.pflags & PF_TAGIT) then return end
		
		local height = v.height()
		local BASEVIDWIDTH = 320
		local NUM_WEAPONS = 7
		xpos, ypos = (BASEVIDWIDTH / 2) - (NUM_WEAPONS * 10) - 6, 176
		nxpos = 20*3
		
		local j = 1
		for i=2,6,2
			local txtflags = V_20TRANS
			flags = oflags
			local canfireweapon = nil
			local infinity = player.powers[pw_infinityring]
			if ((j == 1) and infinity) then
				canfireweapon = true
			elseif (player.rings <= 0)
			or ((j == 2) and (player.rings < 10))
			or ((j == 2) and (player.dirk_dmweapondelay[2] > 0))
			or ((j == 3) and (player.rings < 5))
			or ((j == 3) and (player.dirk_dmweapondelay[3] > 0)) then
				canfireweapon = false
			else
				canfireweapon = true
			end
			local blackindflags = flags
			if (not canfireweapon) then
				flags = $|V_80TRANS
				txtflags = V_TRANSLUCENT
			end
			if (not ((j == 1) and (infinity))) then
				v.draw(8 + xpos, ypos, v.cachePatch("BLACKIND"), blackindflags)
				v.draw(8 + xpos, ypos, v.cachePatch("ICEIND"..tostring(j+1)), flags)
				if ((j == 2) or (j == 3)) then
					local rings = 0
					if (j == 2) then
						rings = 10
					elseif (j == 3) then
						rings = 5
					end
					rings = $-(player.rings)
					if (rings > 0) then
						v.drawString(24 + xpos, ypos + 8, tostring(rings), V_REDMAP|V_SNAPTOLEFT|oflags, "thin-right")
					end
				end
			end
			if (player.currentweapon == ((j-1)*3)) then
				local q = player.weapondelay
				local del = 0
				local p = 16
				while (q) do
					if (q > p) then
						del = del + p
						q = q - p
						q = q / 2
						if (p > 1) then
							p = p / 2
						end
					else
						del = del + q
						break
					end
				end
				v.draw(6 + xpos, ypos-2 - del/2, v.cachePatch("CURWEAP"), V_PERPLAYER|V_SNAPTOBOTTOM)
			end
			xpos = $ + nxpos
			j = $+1
		end
    end
end)

hud.add(function(v)
	if (not netgame) then
		local pwrupdisplay = 0
		if (CV_FindVar ~= nil) then
			pwrupdisplay = CV_FindVar("powerupdisplay").value
		end
		if (pwrupdisplay == 2) then
			dirk_ringslingerstatusbar(v, displayplayer)
		end
	end
end, "scores")
