//Vesola's SRB2 Battle abilities by DirkTheHusky
//Fixes from Lactozilla

/*Man, figuring out the petal darts despawning was a pain in the butt for me.
Why didn't I think about using MobjThinker in the first place for that.
*/

local vesola_cooldown = TICRATE*4
local vesola_shoottime = TICRATE

local VesolaBattle = false
--local B = CBW_Battle

//Functions for the darts
//-------------------------------

local function movedart(dart, fire, dir, xydir)
	if dart and dart.valid then
		P_InstaThrust(dart, fire.angle+dir, xydir)
		P_SetScale(dart, dart.destscale)
	end
end

local function stopdart(dart, xspeed, yspeed, zspeed)
	if dart and dart.valid then
		dart.momx = xspeed
		dart.momy = yspeed
		dart.momz = zspeed
	end
end

local function firedart(dart, sender, speed)
	if dart and dart.valid then
		S_StartSound(dart, sfx_cdfm62)
		P_InstaThrust(dart, sender.angle, speed*FRACUNIT)
	end
end

local function darttrail(dart)
	if dart and dart.valid then
		local trail = P_SpawnGhostMobj(dart)
		trail.fuse = 5
		trail.colorized = true
	end
end

addHook("MobjThinker", function(mobj)
	if mobj.fired then return end

	local target = mobj.target
	if (not target)
	or (target and not target.valid) then
		P_RemoveMobj(mobj)
		return
	end

	local player = target.player
	if (not player)
	or (player and (
		P_PlayerInPain(player)
		or player.playerstate == PST_DEAD
		or player.spectator
		or player.actionstate == 0
	)) then
		P_RemoveMobj(mobj)
	end
end, MT_PETALATTACK)

addHook("MobjSpawn",function(mo)
	mo.hit_sound = sfx_hit03
	mo.blockable = 1
	mo.block_stun = 8
	//mo.block_sound = sfx_s3kb5
	mo.block_hthrust = 7
	mo.block_vthrust = 6
	mo.spawnfire = true
end,MT_PETALTWIRLPIECE)

addHook("MobjSpawn",function(mo)
	mo.hit_sound = sfx_hit03
end,MT_PETALATTACK)

local function DoPlayerKnockback(player, inflictor, source)
	if player.powers[pw_invulnerability]
	or player.powers[pw_flashing]
	or player.powers[pw_super] then
		return
	end

	player.pflags = $ & ~PF_APPLYAUTOBRAKE
	P_ResetPlayer(player)

	player.mo.z = $ + P_MobjFlip(player.mo)

	if (player.mo.eflags & MFE_UNDERWATER) then
		P_SetObjectMomZ(player.mo, FixedDiv(10511*FRACUNIT,2600*FRACUNIT), false)
	else
		P_SetObjectMomZ(player.mo, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
	end

	local ang = R_PointToAngle2(source.x - source.momx, source.y - source.momy, player.mo.x - player.mo.momx, player.mo.y - player.mo.momy)
	local fallbackspeed = max(abs(source.player.speed), FixedMul(4*FRACUNIT, inflictor.scale))

	player.drawangle = ang + ANGLE_180
	P_InstaThrust(player.mo, ang, fallbackspeed)
end

addHook("ShouldDamage", function(target, inflictor, source)
	if (target.player and target.health)
	and (source and source.valid and source.player and (source ~= target))
	and (inflictor and inflictor.valid and (inflictor.type == MT_PETALTWIRLPIECE)) then
		DoPlayerKnockback(target.player, inflictor, source)
		return false
	end
end, MT_PLAYER)

//-------------------------------

//Base attack

local function VesolaSpecial(mo,doaction,pressedaction)
	local player = mo.player
	
	if P_PlayerInPain(player) or player.playerstate == PST_DEAD then
		player.darttime = 0
		player.dartfiretime = 0
		player.actionstate = 0
		player.powers[pw_nocontrol] = 0
	end
	
	if not(CBW_Battle.CanDoAction(player)) 
		player.actionstate = 0
	return end
	
	//Action Info
	player.actiontext = "Petal Bullets"
	player.actionrings = 10

	if player.actionstate != 0 then 
		player.canguard = false
	end
	
	if player.darttime == nil then
		player.darttime = 0
	end
	
	if player.dartfiretime == nil then
		player.dartfiretime = 0
	end
	
	if player.actionstate == 0
		player.darttime = 0
		player.dartfiretime = 0
		player.powers[pw_nocontrol] = 0
		if doaction == 1
			CBW_Battle.PayRings(player)
			player.actionstate = 1
			CBW_Battle.ApplyCooldown(player,vesola_cooldown)
		end
	end
	if player.actionstate
		if player.actionstate == 1
		and not P_PlayerInPain(player)
			player.darttime = $+1
			mo.state = S_PLAY_WALK
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			player.powers[pw_nocontrol] = 1
			
			local firedir = mo.angle // Set up the fire direction
			
			if player.darttime == 1
				player.dart1 = P_SpawnMobj(mo.x, mo.y, mo.z+16*FRACUNIT, MT_PETALATTACK)
				player.dart1.scale = 0
				player.dart1.destscale = 2*FRACUNIT
				player.dart1.color = mo.color
				player.dart1.target = mo
				player.dart1.scale = mo.scale*2
				player.dart1.skin = mo.skin
				player.dart1.flags2 = mo.flags2
				player.dart1.eflags = mo.eflags
				player.dart1.fired = false
				
				S_StartSound(mo, sfx_s3k8e)
				
				player.dart2 = P_SpawnMobj(mo.x, mo.y, mo.z+16*FRACUNIT, MT_PETALATTACK)
				player.dart2.scale = 0
				player.dart2.destscale = 2*FRACUNIT
				player.dart2.color = mo.color
				player.dart2.target = mo
				player.dart2.scale = mo.scale*2
				player.dart2.skin = mo.skin
				player.dart2.flags2 = mo.flags2
				player.dart2.eflags = mo.eflags
				player.dart2.angle = firedir
				player.dart2.fired = false
				
				player.dart3 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PETALATTACK)
				player.dart3.scale = 0
				player.dart3.destscale = 2*FRACUNIT
				player.dart3.color = mo.color
				player.dart3.target = mo
				player.dart3.scale = mo.scale*2
				player.dart3.skin = mo.skin
				player.dart3.flags2 = mo.flags2
				player.dart3.eflags = mo.eflags
				player.dart3.angle = firedir
				player.dart3.fired = false

				player.dart4 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PETALATTACK)
				player.dart4.scale = 0
				player.dart4.destscale = 2*FRACUNIT
				player.dart4.color = mo.color
				player.dart4.target = mo
				player.dart4.scale = mo.scale*2
				player.dart4.skin = mo.skin
				player.dart4.flags2 = mo.flags2
				player.dart4.eflags = mo.eflags
				player.dart4.angle = firedir
				player.dart4.fired = false
				
			end
			
			if player.darttime < TICRATE/2
				movedart(player.dart1, mo, ANGLE_90, 3*mo.scale)
				movedart(player.dart2, mo, ANGLE_270, 3*mo.scale)
				movedart(player.dart3, mo, ANGLE_90, 3*mo.scale)
				movedart(player.dart4, mo, ANGLE_270, 3*mo.scale)
				if player.dart1 and player.dart1.valid then
					P_SetObjectMomZ(player.dart1, FRACUNIT, false)
					player.dart1.scale = mo.scale*2
				end
				if player.dart2 and player.dart2.valid then
					P_SetObjectMomZ(player.dart2, FRACUNIT, false)
					player.dart2.scale = mo.scale*2
				end
				if player.dart3 and player.dart3.valid then
					player.dart3.scale = mo.scale*2
				end
				if player.dart4 and player.dart4.valid then
					player.dart4.scale = mo.scale*2
				end
			elseif player.darttime >= TICRATE/2 and player.darttime < 57
				stopdart(player.dart1, 0, 0, 0)
				stopdart(player.dart2, 0, 0, 0)
				stopdart(player.dart3, 0, 0, 0)
				stopdart(player.dart4, 0, 0, 0)
				if player.dart1 and player.dart1.valid then
					player.dart1.flags = $|MF_MISSILE
					player.dart1.scale = mo.scale*2
				end
				if player.dart2 and player.dart2.valid then
					player.dart2.flags = $|MF_MISSILE
					player.dart2.scale = mo.scale*2
				end
				if player.dart3 and player.dart3.valid then
					player.dart3.flags = $|MF_MISSILE
					player.dart3.scale = mo.scale*2
				end
				if player.dart4 and player.dart4.valid then
					player.dart4.flags = $|MF_MISSILE
					player.dart4.scale = mo.scale*2
				end
			end
			if player.darttime == 40
				if player.dart1 and player.dart1.valid then
					player.dart1.angle = firedir
				end
				if player.dart2 and player.dart2.valid then
					player.dart2.angle = firedir
				end
				if player.dart3 and player.dart3.valid then
					player.dart3.angle = firedir
				end
				if player.dart4 and player.dart4.valid then
					player.dart4.angle = firedir
				end
			
				player.actionstate = 2
			end
		end
		if player.actionstate == 2
			player.dartfiretime = $+1
			if player.dartfiretime == 1
			and player.dart1 and player.dart1.valid
				firedart(player.dart1, player.dart1, 48)
				player.dart1.fired = true
				player.powers[pw_nocontrol] = 0
				P_InstaThrust(mo, mo.angle+ANGLE_180, 16*FRACUNIT)
			elseif player.dartfiretime == 7
			and player.dart2 and player.dart2.valid
				firedart(player.dart2, player.dart2, 72)
				player.dart2.fired = true
			elseif player.dartfiretime == 13
			and player.dart3 and player.dart3.valid
				firedart(player.dart3, player.dart3, 72)
				player.dart3.fired = true
			elseif player.dartfiretime == 19
				if player.dart4 and player.dart4.valid
					firedart(player.dart4, player.dart4, 72)
					player.dart4.fired = true
				end
				player.actionstate = 0
				player.darttime = 0
				player.dartfiretime = 0
				CBW_Battle.ApplyCooldown(player, vesola_cooldown)
			end
		end
		darttrail(player.dart1)
		darttrail(player.dart2)
		darttrail(player.dart3)
		darttrail(player.dart4)
	end
end

//Base Setup!
			
addHook("ThinkFrame",function()
	if (CBW_Battle and not VesolaBattle)
		local function KineticPriorityV(player)
			if player.beeflight
			or player.mo.petaltwirltime
				CBW_Battle.SetPriority(player,1,1,nil,1,1,"Petal Twirl")
			elseif player.hornetsting == 2
				CBW_Battle.SetPriority(player,3,1,"fang_tailbounce",3,1,"Sting Strike")
			end
		end
			
	
		CBW_Battle.SkinVars["vesola"] = {
			weight = 95,
			shields = 1,
			special = VesolaSpecial,
			guard_enabled = true,
			guard_frame = 2,
			func_priority_ext = KineticPriorityV,
		}
	
		VesolaBattle = true
		print("Vesola BattleMod functions have been loaded.")
	end
end)

